> ## Documentation Index
> Fetch the complete documentation index at: https://docs.prequel.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Update destination

> Update an existing destination.



## OpenAPI

````yaml /generated/openapi-generated-2023-12-01.json patch /destinations/{destination_id}
openapi: 3.1.0
info:
  title: Prequel Data Export
  description: Data Export API spec
  version: '2023-12-01'
servers:
  - url: https://api.prequel.co
    description: Cloud-hosted server (US)
  - url: https://eu-api.prequel.co
    description: Cloud-hosted server (EU)
  - url: https://{custom_host}/
    description: Cloud-prem or shared-cloud server
security:
  - ApiKeyAuth: []
paths:
  /destinations/{destination_id}:
    patch:
      tags:
        - Destinations
      summary: Update destination
      description: Update an existing destination.
      operationId: patch-destination
      parameters:
        - name: destination_id
          in: path
          required: true
          description: Destination ID.
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateDestinationRequest'
              $schema: https://json-schema.org/draft/2020-12/schema
              $id: >-
                https://github.com/prequel-co/datafeed/internal/export/api/models/update-destination-request
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                properties:
                  status:
                    type: string
                    const: success
                  data:
                    $ref: '#/components/schemas/DestinationResponse'
                    $schema: https://json-schema.org/draft/2020-12/schema
                    $id: >-
                      https://github.com/prequel-co/datafeed/internal/export/api/models/destination-response
                  message:
                    type: string
                type: object
                required:
                  - status
                  - data
                  - message
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - ApiKeyAuth: []
components:
  schemas:
    UpdateDestinationRequest:
      properties:
        destination:
          $ref: '#/components/schemas/UpdateDestinationOptions'
      additionalProperties: false
      type: object
      required:
        - destination
    DestinationResponse:
      properties:
        destination:
          $ref: '#/components/schemas/DestinationResource'
      additionalProperties: false
      type: object
      required:
        - destination
    UpdateDestinationOptions:
      properties:
        name:
          type: string
          description: >-
            Descriptive and unique name for this destination. This will only be
            visible internally and is only used as a reference.
        frequency_minutes:
          type: integer
          description: >-
            Number of minutes between transfers. Between 15 and 1440 (24 hours).
            Defaults to organization-level default.
        enabled_models:
          items:
            type: string
          type: array
          description: List of models to enable for this destination. If empty
        max_concurrent_transfers:
          type: integer
          description: >-
            The maximum number of transfers that can write to this destination
            at the same time. Transfers with overlapping model assignments
            cannot be run simultaneously.
        max_concurrent_queries_per_transfer:
          type: integer
          description: >-
            The maximum number of queries that can be run in parallel for a
            single transfer. This is used to limit the number of concurrent
            queries that can be run for a single transfer to avoid overloading
            the destination.
        is_enabled:
          type: boolean
          description: Whether the destination is enabled (vs paused).
          default: true
        vendor:
          type: string
          enum:
            - snowflake
            - bigquery
            - redshift
            - databricks
            - athena
            - aurora_mysql
            - aurora_postgres
            - abs
            - clickhouse
            - delta_lake
            - gcs
            - google_sheets
            - iceberg
            - mock
            - mongodb
            - motherduck
            - mysql
            - oracle
            - planetscale
            - postgres
            - redshift_serverless
            - sftp
            - s3
            - s3_compatible
            - sql_server
            - singlestore
          readOnly: true
        abs:
          $ref: '#/components/schemas/UpdateABSDestinationOptions'
          title: Azure Blob Storage
        athena:
          $ref: '#/components/schemas/UpdateAthenaDestinationOptions'
          title: Amazon Athena
        aurora_mysql:
          $ref: '#/components/schemas/UpdateMySQLDestinationOptions'
          title: Amazon Aurora MySQL
        aurora_postgres:
          $ref: '#/components/schemas/UpdatePostgresDestinationOptions'
          title: Amazon Aurora PostgreSQL
        bigquery:
          $ref: '#/components/schemas/UpdateBigQueryDestinationOptions'
          title: Google BigQuery
        clickhouse:
          $ref: '#/components/schemas/UpdateClickhouseDestinationOptions'
          title: ClickHouse
        databricks:
          $ref: '#/components/schemas/UpdateDatabricksDestinationOptions'
          title: Databricks
        delta_lake:
          $ref: '#/components/schemas/UpdateDeltaLakeDestinationOptions'
          title: Delta Lake
        gcs:
          $ref: '#/components/schemas/UpdateGCSDestinationOptions'
          title: Google Cloud Storage
        google_sheets:
          $ref: '#/components/schemas/UpdateGoogleSheetsDestinationOptions'
          title: Google Sheets
        iceberg:
          $ref: '#/components/schemas/UpdateIcebergDestinationOptions'
          title: Iceberg
        mock:
          $ref: '#/components/schemas/UpdateMockDestinationOptions'
          title: Mock (for testing in staging only)
        mongodb:
          $ref: '#/components/schemas/UpdateMongoDBDestinationOptions'
          title: MongoDB
        motherduck:
          $ref: '#/components/schemas/UpdateMotherDuckDestinationOptions'
          title: MotherDuck
        mysql:
          $ref: '#/components/schemas/UpdateMySQLDestinationOptions'
          title: MySQL
        oracle:
          $ref: '#/components/schemas/UpdateOracleDestinationOptions'
          title: Oracle
        planetscale:
          $ref: '#/components/schemas/UpdateMySQLDestinationOptions'
          title: PlanetScale
        postgres:
          $ref: '#/components/schemas/UpdatePostgresDestinationOptions'
          title: PostgreSQL
        redshift:
          $ref: '#/components/schemas/UpdateRedshiftDestinationOptions'
          title: Amazon Redshift
        redshift_serverless:
          $ref: '#/components/schemas/UpdateRedshiftServerlessDestinationOptions'
          title: Amazon Redshift Serverless
        sftp:
          $ref: '#/components/schemas/UpdateSFTPDestinationOptions'
          title: SFTP
        singlestore:
          $ref: '#/components/schemas/UpdateMySQLDestinationOptions'
          title: SingleStore
        snowflake:
          $ref: '#/components/schemas/UpdateSnowflakeDestinationOptions'
          title: Snowflake
        sql_server:
          $ref: '#/components/schemas/UpdateSQLServerDestinationOptions'
          title: SQL Server
        s3:
          $ref: '#/components/schemas/UpdateS3DestinationOptions'
          title: Amazon S3
        s3_compatible:
          $ref: '#/components/schemas/UpdateS3CompatibleDestinationOptions'
          title: S3 Compatible
        machine_type_id:
          type: string
          format: uuid
      additionalProperties: false
      type: object
    DestinationResource:
      oneOf:
        - properties:
            abs:
              $ref: '#/components/schemas/ABSDestinationResource'
          required:
            - abs
          title: abs
        - properties:
            athena:
              $ref: '#/components/schemas/AthenaDestinationResource'
          required:
            - athena
          title: athena
        - properties:
            aurora_mysql:
              $ref: '#/components/schemas/MySQLDestinationResource'
          required:
            - aurora_mysql
          title: aurora_mysql
        - properties:
            aurora_postgres:
              $ref: '#/components/schemas/PostgresDestinationResource'
          required:
            - aurora_postgres
          title: aurora_postgres
        - properties:
            bigquery:
              $ref: '#/components/schemas/BigQueryDestinationResource'
          required:
            - bigquery
          title: bigquery
        - properties:
            clickhouse:
              $ref: '#/components/schemas/ClickhouseDestinationResource'
          required:
            - clickhouse
          title: clickhouse
        - properties:
            databricks:
              $ref: '#/components/schemas/DatabricksDestinationResource'
          required:
            - databricks
          title: databricks
        - properties:
            delta_lake:
              $ref: '#/components/schemas/DeltaLakeDestinationResource'
          required:
            - delta_lake
          title: delta_lake
        - properties:
            gcs:
              $ref: '#/components/schemas/GCSDestinationResource'
          required:
            - gcs
          title: gcs
        - properties:
            google_sheets:
              $ref: '#/components/schemas/GoogleSheetsDestinationResource'
          required:
            - google_sheets
          title: google_sheets
        - properties:
            iceberg:
              $ref: '#/components/schemas/IcebergDestinationResource'
          required:
            - iceberg
          title: iceberg
        - properties:
            mongodb:
              $ref: '#/components/schemas/MongoDBDestinationResource'
          required:
            - mongodb
          title: mongodb
        - properties:
            motherduck:
              $ref: '#/components/schemas/MotherDuckDestinationResource'
          required:
            - motherduck
          title: motherduck
        - properties:
            mysql:
              $ref: '#/components/schemas/MySQLDestinationResource'
          required:
            - mysql
          title: mysql
        - properties:
            oracle:
              $ref: '#/components/schemas/OracleDestinationResource'
          required:
            - oracle
          title: oracle
        - properties:
            planetscale:
              $ref: '#/components/schemas/MySQLDestinationResource'
          required:
            - planetscale
          title: planetscale
        - properties:
            postgres:
              $ref: '#/components/schemas/PostgresDestinationResource'
          required:
            - postgres
          title: postgres
        - properties:
            redshift:
              $ref: '#/components/schemas/RedshiftDestinationResource'
          required:
            - redshift
          title: redshift
        - properties:
            redshift_serverless:
              $ref: '#/components/schemas/RedshiftServerlessDestinationResource'
          required:
            - redshift_serverless
          title: redshift_serverless
        - properties:
            sftp:
              $ref: '#/components/schemas/SFTPDestinationResource'
          required:
            - sftp
          title: sftp
        - properties:
            singlestore:
              $ref: '#/components/schemas/MySQLDestinationResource'
          required:
            - singlestore
          title: singlestore
        - properties:
            snowflake:
              $ref: '#/components/schemas/SnowflakeDestinationResource'
          required:
            - snowflake
          title: snowflake
        - properties:
            sql_server:
              $ref: '#/components/schemas/SQLServerDestinationResource'
          required:
            - sql_server
          title: sql_server
        - properties:
            s3:
              $ref: '#/components/schemas/S3DestinationResource'
          required:
            - s3
          title: s3
        - properties:
            s3_compatible:
              $ref: '#/components/schemas/S3CompatibleDestinationResource'
          required:
            - s3_compatible
          title: s3_compatible
      properties:
        id:
          type: string
          description: The ID of the destination.
        vendor:
          type: string
          description: The vendor of the destination.
        name:
          type: string
          description: The name of the destination.
        frequency_minutes:
          type: integer
          description: The frequency at which the destination will be updated.
        id_in_provider_system:
          type: string
          description: The ID of the destination in the provider's system.
        recipient_id:
          type: string
          description: The ID of the recipient that this destination is associated with.
        products:
          items:
            type: string
          type: array
          description: The list of products that are enabled for this destination.
        enabled_models:
          items:
            type: string
          type: array
          description: The list of models that are enabled for this destination.
        max_concurrent_transfers:
          type: integer
          description: >-
            The maximum number of concurrent transfers allowed for this
            destination.
        max_concurrent_queries_per_transfer:
          type: integer
          description: >-
            The maximum number of queries that can be run in parallel for a
            single transfer. This is used to limit the number of concurrent
            queries that can be run for a single transfer to avoid overloading
            the destination.
        is_enabled:
          type: boolean
          description: Whether the destination is enabled (vs paused).
        created_at:
          type: string
          format: date-time
          description: When this destination was created.
        updated_at:
          type: string
          format: date-time
          description: When this destination was last updated.
        last_successful_transfer_ended_at:
          type: string
          format: date-time
          description: The timestamp when the last successful transfer ended.
        last_completed_transfer:
          $ref: '#/components/schemas/ScannableTransfer'
          description: The ID of the last successful transfer.
        total_rows_transferred_last_billing_period:
          type: integer
        total_delta_rows_transferred_last_billing_period:
          type: integer
        total_rows_transferred_current_billing_period:
          type: integer
      type: object
      required:
        - id
        - vendor
        - name
        - recipient_id
        - created_at
        - updated_at
        - last_successful_transfer_ended_at
      unevaluatedProperties: false
    ErrorResponse:
      properties:
        status:
          type: string
          const: error
        message:
          type: string
        data:
          type: 'null'
      type: object
      required:
        - status
        - message
    UpdateABSDestinationOptions:
      properties:
        folder:
          type: string
          description: >-
            The folder to write to. The folder will be created if it does not
            exist.
        container_name:
          type: string
          description: The name of the container to write to.
        storage_account_name:
          type: string
          description: The name of the storage account configured for Prequel.
        auth_method:
          type: string
          enum:
            - azure_service_shared_access_signature
          description: >-
            Option for authentication methods. Currently only SAS is supported
            and must be set to azure_service_shared_access_signature.
        azure_service_shared_access_signature:
          $ref: '#/components/schemas/UpdateAzureServiceSharedAccessSignature'
          description: >-
            Required parameters to authenticate to Azure using a Service shared
            access signature.
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
          default: false
      additionalProperties: false
      type: object
    UpdateAthenaDestinationOptions:
      properties:
        workgroup:
          type: string
          description: >-
            The Athena workgroup to use for this destination. This should be
            'primary' unless otherwise specified during connection
            configuration.
        connection_database:
          type: string
          description: >-
            The name of the folder in S3 in which the Athena query results are
            written (i.e. the automatically generated athena_output/ data).
        write_database:
          type: string
          pattern: ^[A-Za-z0-9_]+$
          description: >-
            The name of the folder in S3 in which the final data will be
            written.
        auth_method:
          type: string
          enum:
            - aws_iam_role
            - aws_access_keys
          description: The method of authentication to use for this destination.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: >-
            Required details if authenticating using an AWS IAM role
            (recommended).
        aws_access_keys:
          $ref: '#/components/schemas/UpdateAWSAccessKeys'
          description: Required details if authenticating using AWS access keys.
        bucket_s3:
          $ref: '#/components/schemas/UpdateS3BucketParams'
          description: Required details about the S3 bucket used for staging data.
      additionalProperties: false
      type: object
    UpdateMySQLDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the MySQL server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the MySQL server.
        connection_database:
          type: string
          description: The name of the database to connect to.
        write_database:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the database where final data will be written.
        auth_method:
          type: string
          enum:
            - password_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to password_auth.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details for username/password authentication.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the MySQL connection.
      additionalProperties: false
      type: object
    UpdatePostgresDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the PostgreSQL server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the PostgreSQL server.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - password_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to password_auth.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details for username/password authentication.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the PostgreSQL connection.
        connection_timeout_in_seconds:
          type: integer
          minimum: 0
          title: Connection Timeout (in seconds)
          description: Duration to wait for successful connection to Postgres
      additionalProperties: false
      type: object
    UpdateBigQueryDestinationOptions:
      properties:
        project_id:
          type: string
          description: The BigQuery project ID.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - gcp_service_account_role
            - gcp_service_account_key
            - federated_gcp_service_account_role
          title: Auth method
          description: The method of authentication to use for this destination.
        gcp_service_account_role:
          $ref: '#/components/schemas/UpdateGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/UpdateFederatedGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        gcp_service_account_key:
          $ref: '#/components/schemas/UpdateGCPServiceAccountKey'
          description: Required details if authenticating using a GCP service account key.
        bucket_gcs:
          $ref: '#/components/schemas/UpdateBigQueryGCSBucketParams'
          description: Required details about the GCS bucket used for staging data.
      additionalProperties: false
      type: object
      required:
        - auth_method
    UpdateClickhouseDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the ClickHouse server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the ClickHouse server.
        cluster:
          type: string
          description: The name of the ClickHouse cluster to use for this destination.
        connection_database:
          type: string
          description: The name of the database to connect to.
        write_database:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the database where final data will be written.
        auth_method:
          type: string
          enum:
            - password_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to password_auth.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details for username/password authentication.
        bucket_vendor:
          type: string
          enum:
            - bucket_s3
            - bucket_gcs
            - bucket_implicit
          description: Where the staging bucket is hosted.
        bucket_s3:
          $ref: '#/components/schemas/UpdateClickhouseS3BucketParams'
          description: Required details about the S3 bucket used for staging data.
        bucket_gcs:
          $ref: '#/components/schemas/UpdateClickhouseGCSBucketParams'
          description: Required details about the GCS bucket used for staging data.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the ClickHouse connection.
      additionalProperties: false
      type: object
    UpdateDatabricksDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the Databricks server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the Databricks server.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the schema to write to.
        catalog:
          type: string
          description: The name of the catalog to write to.
        http_path:
          type: string
          description: The HTTP path to use for the Databricks connection.
        auth_method:
          type: string
          enum:
            - access_token_auth
            - oauth_client_secret_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to access_token_auth.
        access_token_auth:
          $ref: '#/components/schemas/AccessToken'
          description: The access token authentication object.
        oauth_client_secret_auth:
          $ref: '#/components/schemas/UpdateOauthClientSecretAuth'
          description: The OAuth client secret authentication object.
        metastore:
          type: string
          enum:
            - hive
            - unity_catalog
          description: Metastore type to use.
        hive:
          $ref: '#/components/schemas/UpdateDatabricksHiveOptions'
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      additionalProperties: false
      type: object
    UpdateDeltaLakeDestinationOptions:
      properties:
        bucket_abs:
          $ref: '#/components/schemas/UpdateOpenTableFormatABSBucketParams'
          description: Required details about the ABS bucket used for the delta lake table.
        bucket_gcs:
          $ref: '#/components/schemas/UpdateOpenTableFormatGCSBucketParams'
          description: Required details about the GCS bucket used for the delta lake table.
        bucket_s3:
          $ref: '#/components/schemas/UpdateOpenTableFormatS3BucketParams'
          description: Required details about the S3 bucket used for the delta lake table.
        bucket_s3_compatible:
          $ref: '#/components/schemas/UpdateOpenTableFormatS3CompatibleBucketParams'
          description: >-
            Required details about the S3 compatible bucket used for the delta
            lake table.
        retention_window_days:
          type: integer
          description: The number of days a file must be deleted before it is vacuumed.
          default: 7
        column_mapping_mode:
          type: string
          enum:
            - none
            - id
            - name
          title: Column mapping mode
          description: >-
            Column mapping mode for the Delta Lake table. Use none for no
            mapping; name to track columns by name (allows rename and drop
            without rewrite); or id to track columns by numeric ID.
          default: none
        deletion_vectors_disabled:
          type: boolean
          title: Disable deletion vectors
          description: >-
            Whether to disable deletion vectors. When false: deletions are
            recorded as markers without rewriting table files.
          default: false
        change_data_feed_disabled:
          type: boolean
          title: Disable change data feed
          description: >-
            Whether to disable change data feed. When false: row-level change
            tracking is maintained for the table.
          default: false
      additionalProperties: false
      type: object
    UpdateGCSDestinationOptions:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
          default: false
        folder:
          type: string
          description: >-
            The folder to write to. The folder will be created if it does not
            exist.
        auth_method:
          type: string
          enum:
            - gcp_service_account_role
            - gcs_hmac_keys
            - federated_gcp_service_account_role
          description: The method of authentication to use for this destination.
        gcp_service_account_role:
          $ref: '#/components/schemas/UpdateGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        gcs_hmac_keys:
          $ref: '#/components/schemas/UpdateGCSAccessKeys'
          description: Required details if authenticating using GCS HMAC keys.
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/UpdateFederatedGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        bucket_name:
          type: string
          description: The name of the GCS bucket.
      additionalProperties: false
      type: object
    UpdateGoogleSheetsDestinationOptions:
      properties:
        host:
          type: string
          pattern: ^(https?:\/\/)?(www.)?docs.google.com\/spreadsheets\/d\/.+(\/)?$
          description: The URL of the Google Sheet.
      additionalProperties: false
      type: object
    UpdateIcebergDestinationOptions:
      properties:
        catalog_iceberg_rest:
          $ref: '#/components/schemas/UpdateIcebergRestCatalogParams'
          description: >-
            Required details about the Iceberg Rest Catalog used for the iceberg
            table.
        catalog_glue:
          $ref: '#/components/schemas/UpdateIcebergAwsGlueCatalogParams'
          description: >-
            Required details about the AWS Glue Catalog used for the iceberg
            table.
        catalog_s3_tables:
          $ref: '#/components/schemas/UpdateIcebergAwsS3TablesCatalogParams'
          description: >-
            Required details about the AWS S3 Tables bucket used for the iceberg
            table.
        catalog_google_lakehouse:
          $ref: '#/components/schemas/UpdateIcebergGoogleLakehouseCatalogParams'
          description: >-
            Required details about the Google Lakehouse Catalog used for the
            iceberg table.
        retention_window_days:
          type: integer
          description: >-
            The minimum number of days to retain old snapshots before they are
            expired.
          default: 7
      additionalProperties: false
      type: object
    UpdateMockDestinationOptions:
      properties:
        schema:
          type: string
          description: Mock schema name.
        database:
          type: string
          description: Mock database name.
        error_code:
          type: string
      additionalProperties: false
      type: object
      required:
        - schema
        - database
    UpdateMongoDBDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the MongoDB server.
        port:
          type: integer
          title: Port
          description: Optional. Leave empty If using Atlas.
          default: 27017
        authentication_database:
          type: string
          description: The name of the MongoDB Authentication Database.
        write_database:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the MongoDB database to write to.
        auth_method:
          type: string
          enum:
            - aws_iam_role
            - password_auth
          description: The method of authentication to use for this destination.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: Required details if authenticating using an AWS IAM role.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details if authenticating with username/password.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the MongoDB connection.
      additionalProperties: false
      type: object
    UpdateMotherDuckDestinationOptions:
      properties:
        database:
          type: string
          title: Database
          description: MotherDuck database name.
        schema:
          type: string
          title: Schema
          description: MotherDuck schema name to write to.
        auth_method:
          type: string
          enum:
            - access_token_auth
          description: The method of authentication to use for this destination.
        access_token_auth:
          $ref: '#/components/schemas/AccessToken'
          description: The access token authentication object.
      additionalProperties: false
      type: object
    UpdateOracleDestinationOptions:
      oneOf:
        - properties:
            disable_ssl:
              const: false
            ssl_options:
              $ref: '#/components/schemas/OracleSSLParams'
              description: Required details if using SSL connection.
          required:
            - ssl_options
          title: SSL Enabled
        - properties:
            disable_ssl:
              type: boolean
              description: Whether to disable SSL for the PostgreSQL connection.
          required:
            - disable_ssl
          title: SSL Disabled
      properties:
        host:
          type: string
          description: The hostname of the Oracle database server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the Oracle database server.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - password_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to password_auth.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details for username/password authentication.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      type: object
      unevaluatedProperties: false
    UpdateRedshiftDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the Redshift server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the Redshift server.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: The name of the schema to write to.
        cluster:
          type: string
          description: The name of the Redshift cluster to connect to.
        username:
          type: string
          title: Username
        auth_method:
          type: string
          enum:
            - aws_iam_role
            - password_auth
          title: Auth method
          description: The method of authentication to use for this destination.
        aws_access_keys:
          $ref: '#/components/schemas/UpdateRedshiftAccessKeys'
          description: Required details for username/password authentication.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: Required details if authenticating using an AWS IAM role.
        bucket_s3:
          $ref: '#/components/schemas/UpdateRedshiftS3BucketParams'
          description: Required details about the S3 bucket used for staging data.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      additionalProperties: false
      type: object
      required:
        - auth_method
    UpdateRedshiftServerlessDestinationOptions:
      properties:
        workgroup:
          type: string
          description: The name of the Redshift Serverless workgroup.
        host:
          type: string
          description: The hostname to use to connect.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port to use to connect.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - aws_access_keys
            - aws_iam_role
          title: Auth method
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: Required details if authenticating using an AWS IAM role.
        aws_access_keys:
          $ref: '#/components/schemas/AWSAccessKeys'
          description: Required details if authenticating using AWS access keys.
        bucket_s3:
          $ref: '#/components/schemas/UpdateRedshiftS3BucketParams'
          description: Required details about the S3 bucket used for staging data.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      additionalProperties: false
      type: object
      required:
        - auth_method
    UpdateSFTPDestinationOptions:
      properties:
        username:
          type: string
          description: The username to use for the SFTP connection.
        host:
          type: string
          description: The hostname of the SFTP server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the SFTP server.
        folder:
          type: string
          description: >-
            The folder to write to. The folder will be created if it does not
            exist.
        auth_method:
          type: string
          enum:
            - public_key_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to public_key_auth.
        public_key_auth:
          $ref: '#/components/schemas/UpdatePublicKeyAuth'
          description: Required details for public key authentication.
      additionalProperties: false
      type: object
    UpdateSnowflakeDestinationOptions:
      properties:
        username:
          type: string
          description: The name of the Snowflake user.
        host:
          type: string
          pattern: .*\.snowflakecomputing.com$
          description: The hostname of the Snowflake server.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the Snowflake server.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - password_auth
            - public_key_auth
          description: Authentication method to use for this destination.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordOnlyAuth'
          description: Required details for username/password authentication.
        public_key_auth:
          $ref: '#/components/schemas/PublicKeyAuth'
          description: Required details for public key authentication.
      additionalProperties: false
      type: object
    UpdateSQLServerDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the SQL Server instance.
        port:
          type: integer
          exclusiveMinimum: 0
          description: The port of the SQL Server instance.
        database:
          type: string
          description: The name of the database to connect to.
        schema:
          type: string
          description: The name of the schema to write to.
        auth_method:
          type: string
          enum:
            - password_auth
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to password_auth.
        password_auth:
          $ref: '#/components/schemas/UpdatePasswordAuth'
          description: Required details for username/password authentication.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the SQL Server connection.
        primary_key_collation:
          type: string
          description: >-
            SQL Server collation to use for primary key column. Leave empty to
            use database default collation.
      additionalProperties: false
      type: object
    UpdateS3DestinationOptions:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
          default: false
        folder:
          type: string
          description: >-
            The folder to write to. The folder will be created if it does not
            exist.
        auth_method:
          type: string
          enum:
            - aws_iam_role
            - aws_access_keys
          description: The method of authentication to use for this destination.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: Required details if authenticating using an AWS IAM role.
        aws_access_keys:
          $ref: '#/components/schemas/UpdateAWSAccessKeys'
          description: Required details if authenticating using AWS access keys.
        bucket_name:
          type: string
          description: The name of the S3 bucket.
        bucket_region:
          type: string
          description: >-
            The region of the S3 bucket. Must be a valid [AWS
            region](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Concepts.RegionsAndAvailabilityZones.html)
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      additionalProperties: false
      type: object
    UpdateS3CompatibleDestinationOptions:
      properties:
        host:
          type: string
          description: The hostname of the S3-compatible server.
        port:
          type: integer
          exclusiveMinimum: 0
          title: Port
          default: 443
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
          default: false
        folder:
          type: string
          description: >-
            The folder to write to. The folder will be created if it does not
            exist.
        bucket_name:
          type: string
          description: The name of the S3-compatible bucket to write to.
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the S3-compatible connection.
        auth_method:
          type: string
          enum:
            - access_keys
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to access_keys.
        access_keys:
          $ref: '#/components/schemas/UpdateAccessKeys'
          description: Required details for access key authentication.
        use_ssh_tunnel:
          type: boolean
          title: Use SSH Tunnel
          description: Whether to use an SSH tunnel for the connection.
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelParams'
          description: Required details if using SSH tunneling.
      additionalProperties: false
      type: object
      required:
        - port
    ABSDestinationResource:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
        folder:
          type: string
        container_name:
          type: string
        auth_method:
          type: string
        storage_account_name:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
      additionalProperties: false
      type: object
      required:
        - folder
        - container_name
        - auth_method
        - storage_account_name
    AthenaDestinationResource:
      oneOf:
        - $ref: '#/components/schemas/AthenaDestinationResourceAWSIAMRole'
        - $ref: '#/components/schemas/AthenaDestinationResourceAWSAccessKeys'
      discriminator:
        mapping:
          aws_access_keys:
            $ref: '#/components/schemas/AthenaDestinationResourceAWSAccessKeys'
          aws_iam_role:
            $ref: '#/components/schemas/AthenaDestinationResourceAWSIAMRole'
        propertyName: auth_method
    MySQLDestinationResource:
      properties:
        host:
          type: string
        port:
          type: integer
        connection_database:
          type: string
        write_database:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - connection_database
        - write_database
        - auth_method
        - password_auth
        - use_ssh_tunnel
    PostgresDestinationResource:
      properties:
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
        connection_timeout_in_seconds:
          type: integer
          title: Connection Timeout
          description: Duration to wait for successful connection to Postgres
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - database
        - schema
        - auth_method
        - password_auth
        - use_ssh_tunnel
    BigQueryDestinationResource:
      oneOf:
        - $ref: >-
            #/components/schemas/BigQueryDestinationResourceGCPServiceAccountRole
        - $ref: >-
            #/components/schemas/BigQueryDestinationResourceFederatedGCPServiceAccountRole
        - $ref: '#/components/schemas/BigQueryDestinationResourceGCPServiceAccountKey'
      discriminator:
        mapping:
          federated_gcp_service_account_role:
            $ref: >-
              #/components/schemas/BigQueryDestinationResourceFederatedGCPServiceAccountRole
          gcp_service_account_key:
            $ref: >-
              #/components/schemas/BigQueryDestinationResourceGCPServiceAccountKey
          gcp_service_account_role:
            $ref: >-
              #/components/schemas/BigQueryDestinationResourceGCPServiceAccountRole
        propertyName: auth_method
    ClickhouseDestinationResource:
      properties:
        cluster:
          type: string
        host:
          type: string
        port:
          type: integer
        connection_database:
          type: string
        write_database:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
        bucket_vendor:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/ClickhouseS3BucketResource'
        bucket_gcs:
          $ref: '#/components/schemas/ClickhouseGCSBucketResource'
        disable_ssl:
          type: boolean
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - connection_database
        - write_database
        - auth_method
        - password_auth
        - bucket_vendor
    DatabricksDestinationResource:
      oneOf:
        - properties:
            metastore:
              const: hive
            hive:
              $ref: '#/components/schemas/DatabricksHiveResource'
              title: Hive Metastore
          required:
            - metastore
            - hive
          title: Hive Metastore
        - properties:
            metastore:
              const: unity_catalog
          required:
            - metastore
          title: Unity Catalog Metastore
      properties:
        host:
          type: string
        port:
          type: integer
        schema:
          type: string
        catalog:
          type: string
        http_path:
          type: string
        auth_method:
          type: string
          enum:
            - access_token_auth
            - oauth_client_secret_auth
        oauth_client_secret_auth:
          $ref: '#/components/schemas/OauthClientSecretAuthResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
      type: object
      required:
        - host
        - port
        - schema
        - catalog
        - http_path
        - auth_method
        - use_ssh_tunnel
      unevaluatedProperties: false
    DeltaLakeDestinationResource:
      properties:
        storage:
          type: string
        bucket_abs:
          $ref: '#/components/schemas/OpenTableFormatABSBucketResource'
        bucket_gcs:
          $ref: '#/components/schemas/OpenTableFormatGCSBucketResource'
        bucket_s3:
          $ref: '#/components/schemas/OpenTableFormatS3BucketResource'
        bucket_s3_compatible:
          $ref: '#/components/schemas/OpenTableFormatS3CompatibleBucketResource'
        retention_window_days:
          type: integer
        column_mapping_mode:
          type: string
          enum:
            - none
            - id
            - name
        deletion_vectors_disabled:
          type: boolean
        change_data_feed_disabled:
          type: boolean
      additionalProperties: false
      type: object
      required:
        - storage
        - retention_window_days
        - column_mapping_mode
    GCSDestinationResource:
      oneOf:
        - $ref: >-
            #/components/schemas/GCSDestinationResourceFederatedGCPServiceAccountRole
        - $ref: '#/components/schemas/GCSDestinationResourceGCPServiceAccountRole'
        - $ref: '#/components/schemas/GCSDestinationResourceGCSHMACKeys'
      discriminator:
        mapping:
          federated_gcp_service_account_role:
            $ref: >-
              #/components/schemas/GCSDestinationResourceFederatedGCPServiceAccountRole
          gcp_service_account_role:
            $ref: '#/components/schemas/GCSDestinationResourceGCPServiceAccountRole'
          gcs_hmac_keys:
            $ref: '#/components/schemas/GCSDestinationResourceGCSHMACKeys'
        propertyName: auth_method
    GoogleSheetsDestinationResource:
      properties:
        host:
          type: string
      additionalProperties: false
      type: object
      required:
        - host
    IcebergDestinationResource:
      properties:
        catalog:
          type: string
          enum:
            - catalog_glue
            - catalog_s3_tables
            - catalog_iceberg_rest
            - catalog_google_lakehouse
          title: Catalog
        catalog_iceberg_rest:
          $ref: '#/components/schemas/IcebergRestCatalogResource'
        catalog_s3_tables:
          $ref: '#/components/schemas/IcebergAwsS3TablesCatalogResource'
        catalog_glue:
          $ref: '#/components/schemas/IcebergAwsGlueCatalogResource'
        catalog_google_lakehouse:
          $ref: '#/components/schemas/IcebergGoogleLakehouseCatalogResource'
        retention_window_days:
          type: integer
      additionalProperties: false
      type: object
      required:
        - catalog
        - retention_window_days
    MongoDBDestinationResource:
      oneOf:
        - $ref: '#/components/schemas/MongoDBDestinationResourceAWSIAMRole'
        - $ref: '#/components/schemas/MongoDBDestinationResourcePasswordAuth'
      discriminator:
        mapping:
          aws_iam_role:
            $ref: '#/components/schemas/MongoDBDestinationResourceAWSIAMRole'
          password_auth:
            $ref: '#/components/schemas/MongoDBDestinationResourcePasswordAuth'
        propertyName: auth_method
    MotherDuckDestinationResource:
      properties:
        database:
          type: string
        schema:
          type: string
        auth_method:
          type: string
          enum:
            - access_token_auth
      additionalProperties: false
      type: object
      required:
        - database
        - schema
        - auth_method
    OracleDestinationResource:
      properties:
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - database
        - schema
        - auth_method
        - password_auth
        - use_ssh_tunnel
    RedshiftDestinationResource:
      oneOf:
        - $ref: '#/components/schemas/RedshiftDestinationResourceAWSAccessKeys'
        - $ref: '#/components/schemas/RedshiftDestinationResourceAWSIAMRole'
      discriminator:
        mapping:
          aws_access_keys:
            $ref: '#/components/schemas/RedshiftDestinationResourceAWSAccessKeys'
          aws_iam_role:
            $ref: '#/components/schemas/RedshiftDestinationResourceAWSIAMRole'
        propertyName: auth_method
    RedshiftServerlessDestinationResource:
      oneOf:
        - $ref: >-
            #/components/schemas/RedshiftServerlessDestinationResourceAWSAccessKeys
        - $ref: '#/components/schemas/RedshiftServerlessDestinationResourceAWSIAMRole'
      discriminator:
        mapping:
          aws_access_keys:
            $ref: >-
              #/components/schemas/RedshiftServerlessDestinationResourceAWSAccessKeys
          aws_iam_role:
            $ref: >-
              #/components/schemas/RedshiftServerlessDestinationResourceAWSIAMRole
        propertyName: auth_method
    SFTPDestinationResource:
      oneOf:
        - properties:
            file_encryption:
              const: pgp
            pgp:
              $ref: '#/components/schemas/PGPEncryption'
              description: Required details for PGP encryption.
          required:
            - file_encryption
            - pgp
      properties:
        username:
          type: string
        host:
          type: string
        port:
          type: integer
        folder:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
        auth_method:
          type: string
          enum:
            - public_key_auth
        public_key_auth:
          $ref: '#/components/schemas/PublicKeyAuth'
      type: object
      required:
        - username
        - host
        - port
        - folder
        - file_format
        - auth_method
        - public_key_auth
      unevaluatedProperties: false
    SnowflakeDestinationResource:
      properties:
        username:
          type: string
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
            - public_key_auth
        public_key_auth:
          $ref: '#/components/schemas/PublicKeyAuth'
      additionalProperties: false
      type: object
      required:
        - username
        - host
        - port
        - database
        - schema
        - auth_method
    SQLServerDestinationResource:
      properties:
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        auth_method:
          type: string
          enum:
            - password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
        primary_key_collation:
          type: string
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - database
        - schema
        - auth_method
        - password_auth
        - use_ssh_tunnel
    S3DestinationResource:
      oneOf:
        - $ref: '#/components/schemas/S3DestinationResourceAWSIAMRole'
        - $ref: '#/components/schemas/S3DestinationResourceAWSAccessKeys'
      discriminator:
        mapping:
          aws_access_keys:
            $ref: '#/components/schemas/S3DestinationResourceAWSAccessKeys'
          aws_iam_role:
            $ref: '#/components/schemas/S3DestinationResourceAWSIAMRole'
        propertyName: auth_method
    S3CompatibleDestinationResource:
      properties:
        host:
          type: string
        port:
          type: integer
          exclusiveMinimum: 0
          title: Port
          default: 443
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
        folder:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
        bucket_name:
          type: string
        auth_method:
          type: string
          enum:
            - access_keys
        access_keys:
          $ref: '#/components/schemas/AWSAccessKeysResource'
        disable_ssl:
          type: boolean
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
      additionalProperties: false
      type: object
      required:
        - host
        - port
        - folder
        - bucket_name
        - auth_method
        - use_ssh_tunnel
    ScannableTransfer:
      properties:
        id:
          type: string
        source_ids:
          $ref: '#/components/schemas/StringArray'
        destination_id:
          type: string
        status:
          type: string
        is_full_refresh:
          type: boolean
        models:
          $ref: '#/components/schemas/StringArray'
        model_metrics:
          $ref: '#/components/schemas/TransferModelMetrics'
        models_snapshot:
          $ref: '#/components/schemas/TransferModelsSnapshot'
        log:
          type: string
        submitted_at:
          type: string
          format: date-time
        start_transfer_window_at:
          type: string
          format: date-time
        end_transfer_window_at:
          type: string
          format: date-time
        started_at:
          type: string
          format: date-time
        ended_at:
          type: string
          format: date-time
        rows_transferred:
          type: integer
        delta_rows_transferred:
          type: integer
        volume_transferred_in_mb:
          type: number
        is_debug_mode:
          type: boolean
        tags:
          $ref: '#/components/schemas/TransferTags'
        actor_id:
          type: string
        actor_type:
          type: string
      additionalProperties: false
      type: object
      required:
        - id
        - status
        - is_full_refresh
        - models
        - log
        - submitted_at
        - start_transfer_window_at
        - end_transfer_window_at
        - rows_transferred
        - delta_rows_transferred
        - volume_transferred_in_mb
        - is_debug_mode
        - actor_id
        - actor_type
    UpdateAzureServiceSharedAccessSignature:
      properties:
        shared_access_signature_token:
          type: string
          title: Storage Account SAS Token
      additionalProperties: false
      type: object
    AWSIAMRole:
      properties:
        aws_iam_role_arn:
          type: string
          title: IAM role ARN
          default: arn:aws:iam::123456789012:role/service-role/role-name
      additionalProperties: false
      type: object
      required:
        - aws_iam_role_arn
    UpdateAWSAccessKeys:
      properties:
        access_id:
          type: string
          description: The access key ID to use for authentication.
        secret_key:
          type: string
          description: The secret key to use for authentication.
      additionalProperties: false
      type: object
    UpdateS3BucketParams:
      properties:
        bucket_name:
          type: string
          description: The name of the S3 bucket.
        bucket_region:
          type: string
          description: >-
            The region of the S3 bucket. Must be a valid [AWS
            region](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Concepts.RegionsAndAvailabilityZones.html)
      additionalProperties: false
      type: object
    UpdatePasswordAuth:
      properties:
        username:
          type: string
          description: The username to use for authentication.
        password:
          type: string
          description: The password to use for authentication.
      additionalProperties: false
      type: object
    SSHTunnelParams:
      properties:
        ssh_tunnel_host:
          type: string
          title: SSH tunnel host
        ssh_tunnel_port:
          type: integer
          title: SSH tunnel port
          default: 22
        ssh_tunnel_username:
          type: string
          title: SSH tunnel username
        ssh_public_key:
          type: string
          enum:
            - primary_public_key
            - secondary_public_key
          title: SSH Public Key
          description: >-
            This is the public SSH key that will be used to establish the SSH
            tunnel. It should be added to the list of authorized keys on the
            bastion host.
      additionalProperties: false
      type: object
      required:
        - ssh_tunnel_host
        - ssh_tunnel_port
        - ssh_tunnel_username
    UpdateGCPServiceAccountRole:
      properties:
        service_account_email:
          type: string
          pattern: ^.*gserviceaccount.com$
          format: email
          description: The email of the GCP service account to use for authentication.
        workload_identity_federation_metadata:
          $ref: '#/components/schemas/GcpExternalAccountMetadata'
          title: Workload identity metadata
          description: The federation metadata to use for authentication.
      additionalProperties: false
      type: object
    UpdateFederatedGCPServiceAccountRole:
      properties:
        service_account_email:
          type: string
          pattern: ^.*gserviceaccount.com$
          format: email
          title: Service account email
          default: service-account-name@project-id.iam.gserviceaccount.com
        workload_identity_federation_metadata:
          $ref: '#/components/schemas/GcpExternalAccountMetadata'
          title: Workload identity metadata
      additionalProperties: false
      type: object
      required:
        - service_account_email
    UpdateGCPServiceAccountKey:
      properties:
        service_account_email:
          type: string
          pattern: ^.*gserviceaccount.com$
          format: email
          description: The email of the GCP service account to use for authentication.
        service_account_key:
          description: The full Google-generated JSON service account key object.
      additionalProperties: false
      type: object
    UpdateBigQueryGCSBucketParams:
      properties:
        bucket_name:
          type: string
          description: The name of the GCS bucket.
        bucket_region:
          type: string
          description: >-
            The region of the staging GCS bucket. Must be a valid GCS [bucket
            location](https://cloud.google.com/storage/docs/locations)
      additionalProperties: false
      type: object
    UpdateClickhouseS3BucketParams:
      properties:
        bucket_name:
          type: string
          description: The name of the S3 bucket.
        bucket_region:
          type: string
          description: >-
            The region of the S3 bucket. Must be a valid [AWS
            region](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Concepts.RegionsAndAvailabilityZones.html)
        bucket_auth_method:
          type: string
          enum:
            - aws_iam_role
            - aws_access_keys
          description: Authentication method for S3 bucket.
        aws_access_keys:
          $ref: '#/components/schemas/UpdateAWSAccessKeys'
          description: Required details for access key authentication.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
          description: Required details for AWS IAM role authentication.
      additionalProperties: false
      type: object
    UpdateClickhouseGCSBucketParams:
      properties:
        bucket_name:
          type: string
          description: The name of the GCS bucket.
        gcs_hmac_keys:
          $ref: '#/components/schemas/UpdateGCSAccessKeys'
          description: Required details for GCS HMAC key authentication.
      additionalProperties: false
      type: object
    AccessToken:
      properties:
        access_token:
          type: string
          title: Personal access token
          description: The access token to use for the connection.
      additionalProperties: false
      type: object
      required:
        - access_token
    UpdateOauthClientSecretAuth:
      properties:
        client_id:
          type: string
          title: Client ID
        client_secret:
          type: string
          title: Client Secret
      additionalProperties: false
      type: object
    UpdateDatabricksHiveOptions:
      properties:
        bucket_vendor:
          type: string
          enum:
            - bucket_s3
          description: Where the staging bucket is hosted.
        bucket_s3:
          $ref: '#/components/schemas/UpdateDatabricksS3BucketParams'
          description: Required details if using an S3 bucket for staging data.
      additionalProperties: false
      type: object
    UpdateOpenTableFormatABSBucketParams:
      properties:
        storage_account_name:
          type: string
          description: The name of the storage account configured for Prequel.
        bucket_auth_method:
          type: string
          enum:
            - azure_storage_account_access_key
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to azure_storage_account_access_key.
        azure_storage_account_access_key:
          $ref: '#/components/schemas/UpdateAzureStorageAccountAccessKey'
          description: Required parameters to authenticate to Azure using an access key.
      additionalProperties: false
      type: object
    UpdateOpenTableFormatGCSBucketParams:
      properties:
        bucket_auth_method:
          type: string
          enum:
            - gcp_service_account_role
            - gcp_service_account_key
            - federated_gcp_service_account_role
          description: The method of authentication to use for this destination.
        gcp_service_account_role:
          $ref: '#/components/schemas/UpdateGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        gcp_service_account_key:
          $ref: >-
            #/components/schemas/UpdateOpenTableFormatGCSDestinationServiceAccountKey
          description: Required details if authenticating using a GCP service account key.
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/UpdateFederatedGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
      additionalProperties: false
      type: object
    UpdateOpenTableFormatS3BucketParams:
      properties:
        bucket_auth_method:
          type: string
          enum:
            - aws_iam_role
            - aws_access_keys
          title: Auth method
          description: The method of authentication to use for this destination.
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRole'
        aws_access_keys:
          $ref: '#/components/schemas/AWSAccessKeys'
          description: Required details if authenticating using AWS access keys.
      additionalProperties: false
      type: object
      required:
        - bucket_auth_method
    UpdateOpenTableFormatS3CompatibleBucketParams:
      properties:
        disable_ssl:
          type: boolean
          description: Whether to disable SSL for the S3-compatible connection.
        bucket_auth_method:
          type: string
          enum:
            - access_keys
          description: >-
            Placeholder value in case authentication options are added.
            Currently must be set to access_keys.
        access_keys:
          $ref: '#/components/schemas/UpdateAccessKeys'
          description: Required details for access key authentication.
      additionalProperties: false
      type: object
    UpdateGCSAccessKeys:
      properties:
        access_key:
          type: string
          description: The access key to use for authentication.
        secret:
          type: string
          description: The secret to use for authentication.
      additionalProperties: false
      type: object
    UpdateIcebergRestCatalogParams:
      properties:
        auth_method:
          type: string
          enum:
            - oauth_bearer_token_auth
            - oauth_client_secret_auth
          title: Auth method
          description: The method of authentication to use for this rest catalog.
        oauth_bearer_token_auth:
          $ref: '#/components/schemas/UpdateOauthBearerTokenAuth'
          description: Required details if authenticating with an OAUTH2 bearer token.
        oauth_client_secret_auth:
          $ref: '#/components/schemas/UpdateOauthDelegatedCredentialAuth'
          description: >-
            Required details if authenticating with an OAUTH2 delegated
            credentials.
        storage_options:
          $ref: '#/components/schemas/UpdateIcebergStorageOptionsParams'
        namespace:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          title: Namespace
          description: >-
            Name of collection in which to group written iceberg tables. It will
            be created automatically if the namespace does not exist.
        warehouse:
          type: string
          title: Namespace
          description: >-
            The identifier for the warehouse associated with this REST catalog.
            This might be a storage URI (ex s3://...) or a unique name provided
            by the catalog service.
      additionalProperties: false
      type: object
    UpdateIcebergAwsGlueCatalogParams:
      properties:
        storage_options:
          $ref: '#/components/schemas/UpdateIcebergAwsStorageOptionsParams'
        database:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
      additionalProperties: false
      type: object
    UpdateIcebergAwsS3TablesCatalogParams:
      properties:
        storage_options:
          $ref: '#/components/schemas/UpdateIcebergAwsStorageOptionsParams'
        database:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
        table_bucket_arn:
          type: string
      additionalProperties: false
      type: object
    UpdateIcebergGoogleLakehouseCatalogParams:
      properties:
        project_id:
          type: string
          description: The Google Cloud project ID.
        catalog_name:
          type: string
          description: Name of BigLake catalog.
        schema:
          type: string
          pattern: ^[A-Za-z0-9_.]+([-][A-Za-z0-9_.]+)*$
          description: Name of BigLake schema to create and write data to.
        bucket_name:
          type: string
          description: Name of GCS bucket to use for the Iceberg table data.
        auth_method:
          type: string
          enum:
            - gcp_service_account_role
            - gcp_service_account_key
            - federated_gcp_service_account_role
          description: The method of authentication to use for this catalog.
        gcp_service_account_role:
          $ref: '#/components/schemas/UpdateGCPServiceAccountRole'
          description: Required details if authenticating using a GCP service account role.
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/UpdateFederatedGCPServiceAccountRole'
          description: >-
            Required details if authenticating using Workload Identity
            Federation.
        gcp_service_account_key:
          $ref: >-
            #/components/schemas/UpdateOpenTableFormatGCSDestinationServiceAccountKey
          description: Required details if authenticating using a GCP service account key.
      additionalProperties: false
      type: object
    OracleSSLParams:
      properties:
        wallet:
          type: string
          title: Oracle Wallet
          description: Base64 encoded contents of Oracle Wallet.
      additionalProperties: false
      type: object
    UpdateRedshiftAccessKeys:
      properties:
        password:
          type: string
          title: Password
        access_id:
          type: string
          title: Bucket access ID
        secret_key:
          type: string
          title: Bucket secret key
      additionalProperties: false
      type: object
      required:
        - password
        - access_id
        - secret_key
    UpdateRedshiftS3BucketParams:
      properties:
        bucket_name:
          type: string
          description: The name of the S3 bucket.
        bucket_region:
          type: string
          description: >-
            The region of the S3 bucket. Must be a valid [AWS
            region](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Concepts.RegionsAndAvailabilityZones.html)
      additionalProperties: false
      type: object
    AWSAccessKeys:
      properties:
        access_id:
          type: string
          title: Bucket access ID
        secret_key:
          type: string
          title: Bucket secret key
      additionalProperties: false
      type: object
      required:
        - access_id
        - secret_key
    UpdatePublicKeyAuth:
      properties:
        public_key:
          type: string
          title: Public key
          description: >-
            This is the public SSH key that will be used to establish the SSH
            tunnel. It should be added to the list of authorized keys on the
            bastion host.
      additionalProperties: false
      type: object
    UpdatePasswordOnlyAuth:
      properties:
        password:
          type: string
          title: Password
      additionalProperties: false
      type: object
      required:
        - password
    PublicKeyAuth:
      properties:
        public_key:
          type: string
          enum:
            - primary_public_key
            - secondary_public_key
          title: Public key
          description: >-
            This is the public SSH key that will be used to establish the SSH
            tunnel. It should be added to the list of authorized keys on the
            bastion host.
      additionalProperties: false
      type: object
      required:
        - public_key
    UpdateAccessKeys:
      properties:
        access_id:
          type: string
          description: The access key ID to use for authentication.
        secret_key:
          type: string
          description: The secret key to use for authentication.
      additionalProperties: false
      type: object
    FileFormatCSV:
      properties:
        delimiter:
          type: string
          title: Delimiter
          description: The delimiter to use for the CSV file. Must be a single character.
      additionalProperties: false
      type: object
      required:
        - delimiter
    AthenaDestinationResourceAWSIAMRole:
      properties:
        workgroup:
          type: string
        connection_database:
          type: string
        write_database:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/S3BucketResource'
        auth_method:
          const: aws_iam_role
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRoleResource'
          title: Authenticate using an AWS IAM role (recommended)
      type: object
      required:
        - workgroup
        - connection_database
        - write_database
        - bucket_s3
        - auth_method
        - aws_iam_role
      title: Authenticate using an AWS IAM role (recommended)
      unevaluatedProperties: false
    AthenaDestinationResourceAWSAccessKeys:
      properties:
        workgroup:
          type: string
        connection_database:
          type: string
        write_database:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/S3BucketResource'
        auth_method:
          const: aws_access_keys
        aws_access_keys:
          $ref: '#/components/schemas/AWSAccessKeysResource'
          title: Authenticate using AWS access keys
      type: object
      required:
        - workgroup
        - connection_database
        - write_database
        - bucket_s3
        - auth_method
        - aws_access_keys
      title: Authenticate using AWS access keys
      unevaluatedProperties: false
    PasswordAuthResource:
      properties:
        username:
          type: string
      additionalProperties: false
      type: object
      required:
        - username
    SSHTunnelResource:
      properties:
        ssh_tunnel_host:
          type: string
        ssh_tunnel_port:
          type: integer
        ssh_tunnel_username:
          type: string
        ssh_public_key:
          type: string
      additionalProperties: false
      type: object
    BigQueryDestinationResourceGCPServiceAccountRole:
      properties:
        project_id:
          type: string
        schema:
          type: string
        bucket_gcs:
          $ref: '#/components/schemas/BigQueryGCSBucketResource'
        auth_method:
          const: gcp_service_account_role
        gcp_service_account_role:
          $ref: '#/components/schemas/GCPServiceAccountRoleResource'
          title: Authenticate using a GCP service account (recommended)
      type: object
      required:
        - project_id
        - schema
        - bucket_gcs
        - auth_method
        - gcp_service_account_role
      title: Authenticate using a GCP service account (recommended)
      unevaluatedProperties: false
    BigQueryDestinationResourceFederatedGCPServiceAccountRole:
      properties:
        project_id:
          type: string
        schema:
          type: string
        bucket_gcs:
          $ref: '#/components/schemas/BigQueryGCSBucketResource'
        auth_method:
          const: federated_gcp_service_account_role
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/FederatedGCPServiceAccountRoleResource'
          title: Authenticate using federation (only if self-hosting)
      type: object
      required:
        - project_id
        - schema
        - bucket_gcs
        - auth_method
        - federated_gcp_service_account_role
      title: Authenticate using federation (only if self-hosting)
      unevaluatedProperties: false
    BigQueryDestinationResourceGCPServiceAccountKey:
      properties:
        project_id:
          type: string
        schema:
          type: string
        bucket_gcs:
          $ref: '#/components/schemas/BigQueryGCSBucketResource'
        auth_method:
          const: gcp_service_account_key
        gcp_service_account_key:
          $ref: '#/components/schemas/GCPServiceAccountKeyResource'
          title: Authenticate using direct access
      type: object
      required:
        - project_id
        - schema
        - bucket_gcs
        - auth_method
        - gcp_service_account_key
      title: Authenticate using direct access
      unevaluatedProperties: false
    ClickhouseS3BucketResource:
      properties:
        bucket_name:
          type: string
        bucket_region:
          type: string
        bucket_auth_method:
          type: string
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRoleResource'
        aws_access_keys:
          $ref: '#/components/schemas/AWSAccessKeysResource'
      additionalProperties: false
      type: object
      required:
        - bucket_name
        - bucket_region
        - bucket_auth_method
    ClickhouseGCSBucketResource:
      properties:
        bucket_name:
          type: string
        gcs_hmac_keys:
          $ref: '#/components/schemas/GCSAccessKeysResource'
      additionalProperties: false
      type: object
      required:
        - bucket_name
        - gcs_hmac_keys
    DatabricksHiveResource:
      oneOf:
        - properties:
            bucket_s3:
              $ref: '#/components/schemas/DatabricksS3BucketResource'
          required:
            - bucket_s3
          title: bucket_s3
      properties:
        bucket_vendor:
          type: string
      type: object
      required:
        - bucket_vendor
      unevaluatedProperties: false
    OauthClientSecretAuthResource:
      properties:
        client_id:
          type: string
      additionalProperties: false
      type: object
      required:
        - client_id
    OpenTableFormatABSBucketResource:
      properties:
        container_name:
          type: string
        folder:
          type: string
        storage_account_name:
          type: string
        bucket_auth_method:
          type: string
      additionalProperties: false
      type: object
      required:
        - container_name
        - folder
        - storage_account_name
        - bucket_auth_method
    OpenTableFormatGCSBucketResource:
      oneOf:
        - properties:
            gcp_service_account_role:
              $ref: '#/components/schemas/GCPServiceAccountRoleResource'
          required:
            - gcp_service_account_role
          title: gcp_service_account_role
        - properties:
            federated_gcp_service_account_role:
              $ref: '#/components/schemas/FederatedGCPServiceAccountRoleResource'
          required:
            - federated_gcp_service_account_role
          title: federated_gcp_service_account_role
        - properties:
            gcp_service_account_key:
              $ref: >-
                #/components/schemas/OpenTableFormatGCSDestinationServiceAccountKeyResource
          required:
            - gcp_service_account_key
          title: gcp_service_account_key
      properties:
        bucket_name:
          type: string
          title: GCS bucket name
        folder:
          type: string
        bucket_auth_method:
          type: string
          enum:
            - gcp_service_account_role
            - gcp_service_account_key
      type: object
      required:
        - bucket_name
        - folder
        - bucket_auth_method
      unevaluatedProperties: false
    OpenTableFormatS3BucketResource:
      oneOf:
        - properties:
            bucket_auth_method:
              const: aws_iam_role
            aws_iam_role:
              $ref: '#/components/schemas/AWSIAMRoleResource'
              title: Authenticate using an AWS IAM role (recommended)
          required:
            - bucket_auth_method
            - aws_iam_role
          title: Authenticate using an AWS IAM role (recommended)
        - properties:
            bucket_auth_method:
              const: aws_access_keys
            aws_access_keys:
              $ref: '#/components/schemas/AWSAccessKeysResource'
              title: Authenticate using AWS access keys
          required:
            - bucket_auth_method
            - aws_access_keys
          title: Authenticate using AWS access keys
      properties:
        bucket_name:
          type: string
        bucket_region:
          type: string
        folder:
          type: string
      type: object
      required:
        - bucket_name
        - bucket_region
        - folder
      unevaluatedProperties: false
    OpenTableFormatS3CompatibleBucketResource:
      properties:
        bucket_host:
          type: string
        bucket_port:
          type: integer
          exclusiveMinimum: 0
        folder:
          type: string
        bucket_name:
          type: string
        bucket_auth_method:
          type: string
          enum:
            - access_keys
        access_keys:
          $ref: '#/components/schemas/AWSAccessKeysResource'
        disable_ssl:
          type: boolean
          title: Disable SSL
      additionalProperties: false
      type: object
      required:
        - bucket_host
        - bucket_port
        - folder
        - bucket_name
        - bucket_auth_method
    GCSDestinationResourceFederatedGCPServiceAccountRole:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
        folder:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
        bucket_name:
          type: string
        auth_method:
          const: federated_gcp_service_account_role
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/FederatedGCPServiceAccountRoleResource'
          title: Authenticate using federation (only if self-hosting)
      type: object
      required:
        - folder
        - bucket_name
        - auth_method
        - federated_gcp_service_account_role
      title: Authenticate using federation (only if self-hosting)
      unevaluatedProperties: false
    GCSDestinationResourceGCPServiceAccountRole:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
        folder:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
        bucket_name:
          type: string
        auth_method:
          const: gcp_service_account_role
        gcp_service_account_role:
          $ref: '#/components/schemas/GCPServiceAccountRoleResource'
          title: Authenticate using a GCP service account (recommended)
      type: object
      required:
        - folder
        - bucket_name
        - auth_method
        - gcp_service_account_role
      title: Authenticate using a GCP service account (recommended)
      unevaluatedProperties: false
    GCSDestinationResourceGCSHMACKeys:
      properties:
        disable_manifest:
          type: boolean
          title: Disable Manifest Files
          description: >-
            Disables JSON manifest files (containing validation metadata)
            written with each batch of data.
        folder:
          type: string
        file_format:
          type: string
          enum:
            - parquet
            - csv
            - json
            - jsonl
        csv:
          $ref: '#/components/schemas/FileFormatCSV'
        bucket_name:
          type: string
        auth_method:
          const: gcs_hmac_keys
        gcs_hmac_keys:
          $ref: '#/components/schemas/GCSAccessKeysResource'
          title: Authenticate using GCS HMAC keys
      type: object
      required:
        - folder
        - bucket_name
        - auth_method
        - gcs_hmac_keys
      title: Authenticate using GCS HMAC keys
      unevaluatedProperties: false
    IcebergRestCatalogResource:
      properties:
        host:
          type: string
        port:
          type: integer
        namespace:
          type: string
        warehouse:
          type: string
        auth_method:
          type: string
        oauth_client_secret_auth:
          $ref: '#/components/schemas/OauthDelegatedCredentialAuthResource'
        storage_options:
          $ref: '#/components/schemas/IcebergStorageOptionsResource'
      additionalProperties: false
      type: object
      required:
        - host
        - namespace
        - warehouse
        - auth_method
        - storage_options
    IcebergAwsS3TablesCatalogResource:
      properties:
        storage_options:
          $ref: '#/components/schemas/IcebergAwsStorageOptionsResource'
        namespace:
          type: string
        table_bucket_arn:
          type: string
      additionalProperties: false
      type: object
      required:
        - storage_options
        - namespace
        - table_bucket_arn
    IcebergAwsGlueCatalogResource:
      properties:
        storage_options:
          $ref: '#/components/schemas/IcebergAwsStorageOptionsResource'
        database:
          type: string
      additionalProperties: false
      type: object
      required:
        - storage_options
        - database
    IcebergGoogleLakehouseCatalogResource:
      properties:
        project_id:
          type: string
        catalog_name:
          type: string
        schema:
          type: string
        bucket_name:
          type: string
        auth_method:
          type: string
        gcp_service_account_role:
          $ref: '#/components/schemas/GCPServiceAccountRoleResource'
        federated_gcp_service_account_role:
          $ref: '#/components/schemas/FederatedGCPServiceAccountRoleResource'
        gcp_service_account_key:
          $ref: >-
            #/components/schemas/OpenTableFormatGCSDestinationServiceAccountKeyResource
      additionalProperties: false
      type: object
      required:
        - project_id
        - catalog_name
        - schema
        - bucket_name
        - auth_method
    MongoDBDestinationResourceAWSIAMRole:
      properties:
        host:
          type: string
        port:
          type: integer
        authentication_database:
          type: string
        write_database:
          type: string
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
        auth_method:
          const: aws_iam_role
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRoleResource'
          title: Authenticate using an AWS IAM role (recommended)
      type: object
      required:
        - host
        - port
        - authentication_database
        - write_database
        - use_ssh_tunnel
        - auth_method
        - aws_iam_role
      title: Authenticate using an AWS IAM role (recommended)
      unevaluatedProperties: false
    MongoDBDestinationResourcePasswordAuth:
      properties:
        host:
          type: string
        port:
          type: integer
        authentication_database:
          type: string
        write_database:
          type: string
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        disable_ssl:
          type: boolean
        auth_method:
          const: password_auth
        password_auth:
          $ref: '#/components/schemas/PasswordAuthResource'
          title: Authenticate using a username and password
      type: object
      required:
        - host
        - port
        - authentication_database
        - write_database
        - use_ssh_tunnel
        - auth_method
        - password_auth
      title: Authenticate using a username and password
      unevaluatedProperties: false
    RedshiftDestinationResourceAWSAccessKeys:
      properties:
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        cluster:
          type: string
        username:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/RedshiftS3BucketResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        auth_method:
          const: aws_access_keys
        aws_access_keys:
          $ref: '#/components/schemas/RedshiftAccessKeysResource'
          title: Authenticate using AWS access keys
      type: object
      required:
        - host
        - port
        - database
        - schema
        - cluster
        - username
        - bucket_s3
        - use_ssh_tunnel
        - auth_method
        - aws_access_keys
      title: Authenticate using AWS access keys
      unevaluatedProperties: false
    RedshiftDestinationResourceAWSIAMRole:
      properties:
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        cluster:
          type: string
        username:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/RedshiftS3BucketResource'
        use_ssh_tunnel:
          type: boolean
        ssh_tunnel:
          $ref: '#/components/schemas/SSHTunnelResource'
        auth_method:
          const: aws_iam_role
        aws_iam_role:
          $ref: '#/components/schemas/AWSIAMRoleResource'
          title: Authenticate using an AWS IAM role (recommended)
      type: object
      required:
        - host
        - port
        - database
        - schema
        - cluster
        - username
        - bucket_s3
        - use_ssh_tunnel
        - auth_method
        - aws_iam_role
      title: Authenticate using an AWS IAM role (recommended)
      unevaluatedProperties: false
    RedshiftServerlessDestinationResourceAWSAccessKeys:
      properties:
        workgroup:
          type: string
        host:
          type: string
        port:
          type: integer
        database:
          type: string
        schema:
          type: string
        bucket_s3:
          $ref: '#/components/schemas/RedshiftS3BucketResource'
        auth_method:
          const: aws_access_keys
        aws_access_keys:
          $ref: '#/components/schemas/AWSAccessKeysResource'
          title: Authenticate using AWS access keys
      type: object
      required:
        - workgroup
        - host
        - port
        - database
        - schema
        - bucket_s3
        - auth_method
        - aws_access_keys
      title: Authenticate using AWS access keys
      unevaluatedProperties: false
    RedshiftServerlessDestinationResourceAWSIAMRole:
      properties:
[...]
